"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var current_tutorial_1 = require('./current-tutorial');
var step_utils_1 = require('./step-utils');
var StepListComponent = (function () {
    function StepListComponent(utils, router, activated, parentRoute) {
        this.utils = utils;
        this.router = router;
        this.activated = activated;
        this.parentRoute = parentRoute;
        this.extraLinks = this.extraLinks || [];
    }
    StepListComponent.prototype.getStepLink = function (step) {
        if (this.prefix && this.prefix !== '') {
            return this.prefix + '/' + this.tutorialDetails.baseRoute + step.url;
        }
        else {
            return this.utils.createAbsoluteLink('..' + step.url, this.parentRoute.firstChild);
        }
    };
    StepListComponent.prototype.isCurrent = function (url) {
        return this.router.url === url;
    };
    StepListComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.tutorialToDisplay) {
            Object.keys(this.tutorialToDisplay.versions).forEach(function (versionIdentifier) {
                var version = _this.tutorialToDisplay.versions[versionIdentifier];
                if (version.isLatest) {
                    _this.allSteps = version.steps;
                }
            });
            this.tutorialDetails = this.tutorialToDisplay;
        }
        else {
            this.activated.tutorial.subscribe(function (tutorialToDisplay) {
                _this.tutorialDetails = tutorialToDisplay;
            });
            this.activated.steps.subscribe(function (allSteps) {
                _this.allSteps = allSteps;
            });
        }
    };
    __decorate([
        core_1.Optional(),
        core_1.Input('tutorial'), 
        __metadata('design:type', Object)
    ], StepListComponent.prototype, "tutorialToDisplay", void 0);
    __decorate([
        core_1.Optional(),
        core_1.Input('prefix'), 
        __metadata('design:type', String)
    ], StepListComponent.prototype, "prefix", void 0);
    __decorate([
        core_1.Optional(),
        core_1.Input('extraLinks'), 
        __metadata('design:type', Array)
    ], StepListComponent.prototype, "extraLinks", void 0);
    StepListComponent = __decorate([
        core_1.Component({
            selector: 'steps-list',
            template: "\n<ul *ngIf=\"tutorialDetails\" class=\"tutorial-steps-list\">\n    <li class=\"step-item\" *ngFor=\"let step of allSteps; let i = index;\" [ngClass]=\"{'active-step': isCurrent(getStepLink(step))}\">\n        <a class=\"step-link\" [href]=\"getStepLink(step)\">{{i + 1}}. {{step.name}}</a>\n    </li>\n    <li class=\"step-item extra-item\" *ngFor=\"let extraLink of extraLinks;\">\n        <a [className]=\"'step-link extra-link ' + (extraLink.bold ? 'bold' : '')\" [href]=\"extraLink.link || ''\">{{extraLink.name}}</a>\n    </li>\n</ul>"
        }),
        core_1.Injectable(), 
        __metadata('design:paramtypes', [step_utils_1.StepsUtils, router_1.Router, current_tutorial_1.ActivatedTutorial, router_1.ActivatedRoute])
    ], StepListComponent);
    return StepListComponent;
}());
exports.StepListComponent = StepListComponent;
//# sourceMappingURL=steps-list.component.js.map