"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var rxjs_1 = require('rxjs');
var http_1 = require('@angular/http');
var core_1 = require('@angular/core');
var marked = require('marked');
var cache = {};
var StepsTemplatesLoader = (function () {
    function StepsTemplatesLoader(http) {
        this.http = http;
        this.cache = new Map();
    }
    StepsTemplatesLoader.prototype.escapeAngularBindings = function (html) {
        return html.replace(/[{}]/g, function (match) {
            return '<span>{{ \'' + match + '\' }}</span>';
        });
    };
    StepsTemplatesLoader.prototype.convertToHtmlTags = function (tutorialName, markdown) {
        return markdown.replace(/\{\{\{(diffStep|diff_step) ["]{0,1}([0-9\.]*)["]{0,1}.*?\}\}\}/g, function (allMatch, temp, stepNumber) {
            return "<diffbox tutorial=\"" + tutorialName + "\" step=\"" + stepNumber + "\"></diffbox>";
        }).replace(/\{\{\{navStep .*?\}\}\}/g, '');
    };
    StepsTemplatesLoader.prototype.load = function (tutorialName, url) {
        if (cache[url]) {
            return rxjs_1.Observable.of(cache[url]);
        }
        else {
            return this.http
                .get('https://raw.githubusercontent.com/' + url)
                .map(function (res) { return res.text(); })
                .map(this.convertToHtmlTags.bind(this, tutorialName))
                .map(function (text) { return marked(text); })
                .map(this.escapeAngularBindings)
                .do(function (item) {
                cache[url] = item;
            });
        }
    };
    StepsTemplatesLoader = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], StepsTemplatesLoader);
    return StepsTemplatesLoader;
}());
exports.StepsTemplatesLoader = StepsTemplatesLoader;
//# sourceMappingURL=steps-templates-loader.js.map