"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var rxjs_1 = require('rxjs');
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var patch_parser_1 = require('./patch-parser');
function capitalizeFirstLetter(message) {
    return message.charAt(0).toUpperCase() + message.slice(1);
}
function prepareSummary(message) {
    return capitalizeFirstLetter(message.trim());
}
function parseOutStepNumberAndComment(arr) {
    arr.forEach(function (parsedPatch) {
        var splitMessage = parsedPatch.message.split(':');
        if (splitMessage.length > 1) {
            var stepNumber = splitMessage[0].split(' ')[1];
            if (!stepNumber) {
                stepNumber = splitMessage[0].split(' ')[0];
            }
            parsedPatch.stepNumber = stepNumber.trim();
            if (splitMessage[1]) {
                parsedPatch.summary = prepareSummary(splitMessage[1]);
            }
        }
    });
    return arr;
}
function doMapping(parsedData) {
    var stepToPatch = {};
    parsedData.forEach(function (parsedPatch) {
        stepToPatch[parsedPatch.stepNumber] = parsedPatch;
    });
    return stepToPatch;
}
var cache = {};
var TutorialRegistryCache = (function () {
    function TutorialRegistryCache(http) {
        this.http = http;
    }
    TutorialRegistryCache.prototype.load = function (id, revision, tutorialData) {
        var _this = this;
        if (cache[id + '_' + revision]) {
            return rxjs_1.Observable.of(cache[id + '_' + revision]);
        }
        else {
            var rootUrl = 'https://api.github.com/repos/' + tutorialData.gitHub + '/commits?path=/.tortilla/manuals/templates/root.tmpl&sha=' + revision;
            var alternativeRootUrl_1 = 'https://api.github.com/repos/' + tutorialData.gitHub + '/commits?path=/manuals/templates/root.md.tmpl&sha=' + revision;
            return this.http.get(rootUrl)
                .map(function (res) { return res.json(); })
                .map(function (res) { return res && res[0] && res[0].sha ? res[0].sha : null; })
                .flatMap(function (res) { return res === null ?
                _this.http.get(alternativeRootUrl_1).do(function () { return console.log('Loading legacy', alternativeRootUrl_1); }).map(function (res) { return res.json(); })
                    .map(function (res) { return res && res[0] && res[0].sha ? res[0].sha : null; }) :
                rxjs_1.Observable.of(res); })
                .flatMap(function (firstCommitId) {
                if (!firstCommitId) {
                    throw new Error('Unable to find first commit with root.tmpl modification!');
                }
                var url = 'https://github.com/' + tutorialData.gitHub + '/compare/' + firstCommitId + '...' + revision + '.patch';
                console.log('Will load path from URL: ', url);
                return _this.http.get(url);
            })
                .map(function (res) { return res['text'](); })
                .map(patch_parser_1.parseMultiPatch)
                .map(parseOutStepNumberAndComment)
                .map(doMapping)
                .map(function (parsedTutorial) {
                var cacheItem = {
                    steps: parsedTutorial,
                    tutorial: tutorialData
                };
                cache[id + '_' + revision] = cacheItem;
                return cacheItem;
            });
        }
    };
    TutorialRegistryCache = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], TutorialRegistryCache);
    return TutorialRegistryCache;
}());
exports.TutorialRegistryCache = TutorialRegistryCache;
//# sourceMappingURL=tutorials-registry-cache.js.map